{{
  Karplus-Strong demo
}}

CON
  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000
  sr            = 44_100        ' let's run at the CD sampling rate
  sustain_value = 8
  demo_pinL     = 11
  demo_pinR     = 10

OBJ
  ks[2]         : "Karplus-Strong-1a"                      ' left channel information should be heard from your left speaker...

PUB test_KS | rn, p

  ' set up using the demo board pins for the headphones
  ks[0].start( demo_pinL, -1, sr )
  ks[1].start( demo_pinR, -1, sr )

  waitcnt( clkfreq >> 3 + cnt )

  ks[0].set_sustain( 12 )
  ks[1].set_sustain( 12 )

  ' play the scale
  rn := 10
  repeat
    ' wait a bit
    waitcnt( clkfreq / 4 + cnt )

    ' set a note (MIDI spec), immediately updated, whether you pluck the string or not
    ks[0].set_note( rn )
    ks[1].set_note( rn + 4 )

    ' pluck both, at different time
    if (rn & %11) == 0
      ks[0].pluck( 31 )
    if (rn & %11) == 2
      ks[1].pluck( 31 )

    ' next note?
    ++rn
    rn //= 128

